document.addEventListener("DOMContentLoaded", function () {
    const tabs = document.querySelectorAll('[id^="nav-"][id$="-tab"]');
    const btc_coin = document.getElementsByClassName('btc_coin');
    console.log(btc_coin, "btc_coin");
    console.log(tabs, "tabs");

    let coinRate = 0;
    let tokenRate = 0;
    let payValue = 0;
    let receiveValue = 0;
    let urlv = getBaseURL() + "/get_coin_rate";
    let tabClicked = false;

    tabs.forEach(tab => {
        tab.addEventListener('click', function () {
            tabClicked = true;
            const coinName = this.getAttribute('data-name');
            console.log(coinName,"nameof Coin");
            if (!coinName) {
                return;
            }
            $.ajax({
                url: urlv,
                method: "GET",
                data: {
                    coin_name: coinName
                },
                success: function (res) {
                    console.log(res, "res");

                    coinRate = res.coin_rate;
                    tokenRate = res.token_rate;

                    const payInput = document.querySelector(`input[data-coin="${coinName}"]`);
                    console.log(payInput, 'payInput');
                    const receiveInput = document.querySelector(`input[data-coin="${coinName}-hinu"]`);
                    console.log(receiveInput, 'receiveInput');
                    $(`input[data-coin="${coinName}"],input[data-coin="${coinName}-hinu"]`).on("keypress", function (evt) {
                        const inputValue = evt.target.value;
                    
                        // Allow backspace
                        if (evt.which === 8) return;
                    
                        // Allow only one decimal point
                        if (evt.which === 46 && inputValue.includes('.')) {
                            evt.preventDefault();
                            return;
                        }
                    
                        // Allow digits (0-9) and the first decimal point
                        if (evt.which < 48 || evt.which > 57) {
                            if (evt.which !== 46) {
                                evt.preventDefault();
                            }
                        }
                    });
                    if (payInput && receiveInput) {
                        payInput.addEventListener('input', function () {
                            payValue = parseFloat(this.value);
                            if (!isNaN(payValue)) {
                                receiveValue = (payValue * coinRate) / tokenRate;
                                console.log("---------------------- receiveValue"+ receiveValue);
                                receiveInput.value = receiveValue.toFixed(8);
                            } else {
                                receiveInput.value = 0;
                            }
                        });

                        receiveInput.addEventListener('input', function () {
                            receiveValue = parseFloat(this.value);
                            if (!isNaN(receiveValue) && coinRate !== 0 && tokenRate !== 0) {
                                payValue = (receiveValue*tokenRate)/coinRate;
                                payInput.value = payValue.toFixed(8);
                            } else {
                                payInput.value = 0;
                            }
                        });
                    } else {
                        console.error(`Input elements for coin ${coinName} not found`);
                    }
                }
            });
        });
    });
 
    window.addEventListener('DOMContentLoaded', function() {
        $.ajax({
            url: urlv,
            method: "GET",
            data: {
                coin_name: 'btc'
            },
            success: function (res) {
                console.log(res, "res");

                coinRate = res.coin_rate;
                tokenRate = res.token_rate;
            }
        });
      });

    document.addEventListener('click', function () {
        if (!tabClicked) {
            console.log("reached");
            console.log("============= coinRate"+coinRate);
            let c_rate = coinRate;
            let t_rate =tokenRate; //5;
            console.log("============= t_rate "+tokenRate);

            $("#coinNameBtc,#coinValueBTC").on("keypress", function (evt) {
                const inputValue = evt.target.value;
            
                // Allow backspace
                if (evt.which === 8) return;
            
                // Allow only one decimal point
                if (evt.which === 46 && inputValue.includes('.')) {
                    evt.preventDefault();
                    return;
                }
            
                // Allow digits (0-9) and the first decimal point
                if (evt.which < 48 || evt.which > 57) {
                    if (evt.which !== 46) {
                        evt.preventDefault();
                    }
                }
            });
            const payInput = document.getElementById('coinNameBtc');
            
                
            console.log('payInput---------------------' +payInput);
            const receiveInput = document.getElementById('coinValueBTC');
            console.log('receiveInput---------------------' +receiveInput);

            const payInputValue = payInput.addEventListener('input', function () {
                const coinValue = parseFloat(this.value);
                console.log(" coinValue--------------"+coinValue);

                if (!isNaN(coinValue)) {
                    receiveValue = (coinValue * c_rate) / t_rate;
                    receiveInput.value = receiveValue.toFixed(8);
                } else {
                    receiveInput.value = 0;
                }
            });
            const recValue = receiveInput.addEventListener('input', function () {
                const coinRecValue = parseFloat(this.value);
                console.log(" coinRecValue--------------"+coinRecValue);
                if (!isNaN(coinRecValue)) {
                    payValue = (coinRecValue * t_rate)/c_rate;
                    payInput.value = payValue.toFixed(8);
                } else {
                    payInput.value = 0;
                }
            });
        }
    });

    window.buyNow = function (coinName) {
        var spinnerIconSelector = '#spinnerIcon' + coinName.toUpperCase();
        var buyNowBtnSelector = '#buyNow' + coinName.toUpperCase();
        $(spinnerIconSelector).removeClass('d-none');
        $(buyNowBtnSelector).prop('disabled', true);
        if (coinRate !== 0 && tokenRate !== 0 && !isNaN(payValue) && !isNaN(receiveValue)) {
            console.log("Coin Name:", coinName, "Pay Value:", payValue, "Receive Value:", receiveValue);
            if( payValue == 0){
                payValue =$("#coinNameBtc").val();               
            }
            var data = {
                coinName: coinName,
                payValue: payValue,
                receiveValue: receiveValue
            };
            var purl = getBaseURL() + "/crypto-pay";

            postAjax(purl, data, function (res) {
                console.log(res, "res");
                if (res.flag == 1) {
                    $(spinnerIconSelector).addClass('d-none');
                    setCookie('user_id', res.user_id, 7);
                    setCookie('order_id', res.order_id, 7);
                    setCookie('currency', res.currency, 7);
                    setCookie('currency_symbol', res.currency_symbol, 7);
                    setCookie('payment_address', res.payment_address, 7);
                    setCookie('payment_qr', res.payment_qr, 7);
                    setCookie('status', res.status, 7);
                    setCookie('currency_image', res.currency_image, 7);
                    // $('#paymentDetails').html(res.blade);
                    Toast(res.msg, 3000, res.flag);
                    setTimeout(function () {
                        location.reload();
                    }, 2000);
                } else if(res.flag == 2){
                    $(spinnerIconSelector).addClass('d-none');
                    $(buyNowBtnSelector).prop('disabled', false);
                    $("#disconnectConformation").modal("show");
                    $("#nobtn").css('display','none');
                    $("#FinalyDisconnet").css('display','none');
                    $("#okayBtn").removeClass('d-none');
                    $("#text").text(`Paying amount must greater than ${res.minimum_amount} ${res.coin}`);
                }else{
                    var cookies = document.cookie.split(";");                   
                    for (var i = 0; i < cookies.length; i++) {
                        var cookie = cookies[i];
                        while (cookie.charAt(0) == ' ') {
                            cookie = cookie.substring(1);
                        }
                        if (cookie.indexOf("currency_image=") == 0 ||
                            cookie.indexOf("XSRF-TOKEN=") == 0 ) {
                            var parts = cookie.split("=");
                            var name = parts[0];
                            var path = "/";
                            document.cookie = name + "=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=" + path;
                        }
                    }
                    $(spinnerIconSelector).addClass('d-none');
                    $(buyNowBtnSelector).prop('disabled', false);
                    Toast(res.msg, 3000, res.flag);
                    setTimeout(function () {
                        location.reload(true);
                    }, 1000);
                }
            });
        } else {
            console.error('Values are not properly initialized or valid.');
        }
    };
});

    window.buyNow = function (coinName) {
        var spinnerIconSelector = '#spinnerIcon' + coinName.toUpperCase();
        var buyNowBtnSelector = '#buyNow' + coinName.toUpperCase();
        $(spinnerIconSelector).removeClass('d-none');
        $(buyNowBtnSelector).prop('disabled', true);
        if (coinRate !== 0 && tokenRate !== 0 && !isNaN(payValue) && !isNaN(receiveValue)) {
            console.log("Coin Name:", coinName, "Pay Value:", payValue, "Receive Value:", receiveValue);
            var data = {
                coinName: coinName,
                payValue: payValue,
                receiveValue: receiveValue
            };
            var purl = getBaseURL() + "/crypto-pay";

            postAjax(purl, data, function (res) {
                console.log(res, "res");
                if (res.flag == 1) {
                    $(spinnerIconSelector).addClass('d-none');
                    setCookie('user_id', res.user_id, 7);
                    setCookie('order_id', res.order_id, 7);
                    setCookie('currency', res.currency, 7);
                    setCookie('currency_symbol', res.currency_symbol, 7);
                    setCookie('payment_address', res.payment_address, 7);
                    setCookie('payment_qr', res.payment_qr, 7);
                    setCookie('status', res.status, 7);
                    setCookie('currency_image', res.currency_image, 7);
                    // $('#paymentDetails').html(res.blade);
                    Toast(res.msg, 3000, res.flag);
                    setTimeout(function () {
                        location.reload();
                    }, 2000);
                } else {
                    $(spinnerIconSelector).removeClass('d-none');
                    $(buyNowBtnSelector).prop('disabled', false);
                    Toast(res.msg, 3000, res.flag);
                }
            });
        } else {
            console.error('Values are not properly initialized or valid.');
        }
    };



function newOrder() {
    var cookies = document.cookie.split(";");

    for (var i = 0; i < cookies.length; i++) {
        var cookie = cookies[i];
        while (cookie.charAt(0) == ' ') {
            cookie = cookie.substring(1);
        }
        if (cookie.indexOf("user_id=") == 0 ||
            cookie.indexOf("order_id=") == 0 ||
            cookie.indexOf("currency=") == 0 ||
            cookie.indexOf("currency_symbol=") == 0 ||
            cookie.indexOf("payment_address=") == 0 ||
            cookie.indexOf("payment_qr=") == 0 ||
            cookie.indexOf("status=") == 0) {
            var parts = cookie.split("=");
            var name = parts[0];
            var path = "/";
            document.cookie = name + "=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=" + path;
        }
    }

    // Set timeout to reload the page after 2 seconds (2000 milliseconds)
    setTimeout(function() {
        location.reload();
    }, 2000);
}

function copyClipAddress() {
    var copyText = document.getElementById("myInputData").innerText;

    var textarea = document.createElement("textarea");
    textarea.value = copyText;
    document.body.appendChild(textarea);
    textarea.select();

    try {
        var successful = document.execCommand('copy');
        if (successful) {
            Toast('Copied', 1, 3000);
        } else {
            Toast('Copied', 1, 3000);
            console.error('Fallback: Unable to copy text');
        }
    } catch (err) {
        Toast('Copied', 1, 3000);
        console.error('Fallback: Unable to copy text: ', err);
    }

    document.body.removeChild(textarea);
}


function copyQRAddress() {
    var copyText = document.getElementById("solQR").innerText.trim();
    
    var textarea = document.createElement("textarea");
    textarea.value = copyText;
    
    // Hide the textarea from view
    textarea.style.position = 'fixed';
    textarea.style.opacity = 0;
    
    document.body.appendChild(textarea);
    
    textarea.select();
    
    try {
      var successful = document.execCommand('copy');
      if (successful) {
          Toast('Copied', 3000, 1);
        console.log('Copied to clipboard');
        // Replace Toast with your actual toast function
      } else {
        console.error('Fallback: Unable to copy text');
      }
    } catch (err) {
      console.error('Fallback: Unable to copy text: ', err);
    }
    
    document.body.removeChild(textarea);
  }

function setCookie(name, value, days) {
    var expires = "";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toUTCString();
    }
    document.cookie = name + "=" + (value || "") + expires + "; path=/";
}

function getCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
}
if($('#cookieUserId').val()){
    var timer = setInterval(orderStatus, 10000);
  }
function orderStatus(){
    let statusUrl = getBaseURL() + "/get-order-stauts";
    let historyUrl = getBaseURL() + "/history";
    $.ajax({
        url: statusUrl,
        method: "POST",
        data: {
            order_id:$("#order_id").val(),
            _token: getCsrftoken()
        },
        success: function (res) {
            if(res.flag == 1 ){
                if(res.data.status == 1 || res.data.status == 2){
                    if(res.data.currency == 'USDTERC20' || res.data.currency == 'USDTTRC20'){
                        var paid_amount = (res.data.paid_amount).toFixed(2)+' '+(res.data.currency);
                    }else{
                        var paid_amount = (res.data.paid_amount).toFixed(8)+' '+(res.data.currency);
                    }
                    console.log('--------------res fetch --------------------')
                    $("#user_amount").text("Your purchased $HINU : "+(res.data.user.totalAmount).toFixed(8));
                    $("#payment-div").html(` <div class="p--status text-center">
                            <div class="p-icon">
                                <svg id="fi_10629607" enable-background="new 0 0 128 128" height="100" viewBox="0 0 128 128" width="100" xmlns="http://www.w3.org/2000/svg">
                                    <g>
                                        <path class="rotate-animation" d="m124 64c0 5.12-6.29 9.34-7.55 14.06-1.3 4.88 1.99 11.68-.48 15.95-2.51 4.34-10.06 4.86-13.58 8.38s-4.04 11.07-8.38 13.58c-4.27 2.47-11.07-.82-15.95.48-4.72 1.26-8.94 7.55-14.06 7.55s-9.34-6.29-14.06-7.55c-4.88-1.3-11.68 1.99-15.95-.48-4.34-2.51-4.86-10.06-8.38-13.58s-11.07-4.04-13.58-8.38c-2.47-4.27.82-11.07-.48-15.95-1.26-4.72-7.55-8.94-7.55-14.06s6.29-9.34 7.55-14.06c1.3-4.88-1.99-11.68.48-15.95 2.51-4.34 10.06-4.86 13.58-8.38s4.04-11.07 8.38-13.58c4.27-2.47 11.07.82 15.95-.48 4.72-1.26 8.94-7.55 14.06-7.55s9.34 6.29 14.06 7.55c4.88 1.3 11.68-1.99 15.95.48 4.34 2.51 4.86 10.06 8.38 13.58s11.07 4.04 13.58 8.38c2.47 4.27-.82 11.07.48 15.95 1.26 4.72 7.55 8.94 7.55 14.06z" fill="#2bb265"></path>
                                        <path d="m81.34 46.12-22.84 22.84-11.84-11.83c-2.57-2.57-6.74-2.57-9.31 0-2.57 2.57-2.57 6.74 0 9.31l16.61 16.61c2.5 2.5 6.56 2.5 9.06 0l27.62-27.62c2.57-2.57 2.57-6.74 0-9.31-2.57-2.57-6.73-2.57-9.3 0z" fill="#ffffff"></path>
                                    </g>
                                </svg>
                            </div>
                            <h2>Your order for purchasing <br><span class="text-orrange">$HINU</span> is completed</h2>
                           <h3>Your purchase order for $HINU of ${ paid_amount } has been successfully completed, giving you <span id="hinu_token">${(res.data.token_amount).toFixed(8)}</span> tokens.</h3><h3 class="text-danger">Please join our <a href="https://t.me/thehuskyinu" target="_blank" style='text-decoration:none' >Telegram channel</a> to stay updated on when to
		claim tokens</h3>
                        </div><div class="order-btn text-center mt-30"> 
                        
                            <a class="theme-btn" href="${historyUrl}">View order history</a>
                            <button class="theme-btn" type="button" onclick="newOrder()" id="newOrder" href="javascript:void(0)">New Order</button>
                        </div> <div class="c--text mt-15 text-center">
                            <p>Widget Powered by: <b><a href="https://coinremitter.com/" target="_blank">Coinremitter</a></b></p>
                        </div>`)
                        console.log('--------------res fetch 1 --------------------')
                    clearInterval(timer);
                    console.log('--------------clear interval --------------------')

                }
                // else{
                //     if(res.data.currency == 'USDTERC20' || res.data.currency == 'USDTTRC20'){
                //         var paid_amount =  (res.data.paid_amount).toFixed(2)+' '+(res.data.currency);
                //         var pending_amount = (res.data.pending_amount).toFixed(2)+' '+(res.data.currency)
                //     }else{
                //         var paid_amount =  (res.data.paid_amount).toFixed(8)+' '+(res.data.currency);
                //         var pending_amount = (res.data.pending_amount).toFixed(8)+' '+(res.data.currency)
                //     }
                //     $(".p--amount").html(`<div class="pa-list">
                //                 <span>Paid Amount</span>
                //                 <h2>${paid_amount}</h2>
                //             </div><div class="pa-list">
                //                 <span>Pending Amount</span>
                //                 <h2>${pending_amount}</h2>
                //             </div>`)
                // }
            }
        }
    })    
}
$("#connectAccNo").on("click",function(){
    $("#disconnectConformation").modal("hide");
    $("#nobtn").css("display", 'inline-block');
    $("#okayBtn").addClass("d-none");
    $("#text").text("Are you sure want to disconnect wallet?");
    $("#FinalyDisconnet").css("display", 'inline-block');
})

function copyWlt_Address() {
    var copyText = $("#user_walletAddress").text().trim();
    
    var textarea = document.createElement("textarea");
    textarea.value = copyText;
    
    // Hide the textarea from view
    textarea.style.position = 'fixed';
    textarea.style.opacity = 0;
    
    document.body.appendChild(textarea);
    
    textarea.select();
    
    try {
      var successful = document.execCommand('copy');
      if (successful) {
          Toast('Copied', 3000, 1);
        console.log('Copied to clipboard');
        // Replace Toast with your actual toast function
      } else {
        console.error('Fallback: Unable to copy text');
      }
    } catch (err) {
      console.error('Fallback: Unable to copy text: ', err);
    }
    
    document.body.removeChild(textarea);
  }

