const wagmiOptions = window.wagmiOptions.wagmiCore;
const onConnectRedirectLink = getBaseURL();
const onSignMessageRedirectLink = getBaseURL()+'/login-call';

console.log(wagmiOptions, 'wagmiOptions');
console.log(window.wagmiOptions, 'wagmiOptions');

const modal = window.wagmiOptions.modal;
const getAccount = wagmiOptions.getAccount;
const signMessage = wagmiOptions.signMessage;
const getBalance = wagmiOptions.getBalance;
const disconnect = wagmiOptions.disconnect;
const connect = wagmiOptions.connect;
var dappKeyPair;
const platform = getPlatform();
if(platform &&  (platform!= "Desktop")){
    var storedKeyPair = localStorage.getItem('dappKeyPair');
    if (storedKeyPair) {
        // If dappKeyPair exists in localStorage, parse and use it
        var keyPair = JSON.parse(storedKeyPair);
        dappKeyPair = {
            publicKey: new Uint8Array(keyPair.publicKey),
            secretKey: new Uint8Array(keyPair.secretKey)
        };
    } else {
        // Generate new dappKeyPair and store it in localStorage
        dappKeyPair = nacl.box.keyPair();
        localStorage.setItem('dappKeyPair', JSON.stringify({
            publicKey: Array.from(dappKeyPair.publicKey),
            secretKey: Array.from(dappKeyPair.secretKey)
        }));
    }
}
var to_b58 = function (B, A) { var d = [], s = "", i, j, c, n; for (i in B) { j = 0, c = B[i]; s += c || s.length ^ i ? "" : 1; while (j in d || c) { n = d[j]; n = n ? n * 256 + c : c; c = n / 58 | 0; d[j] = n % 58; j++ } } while (j--) s += A[d[j]]; return s };
var from_b58 = function (S, A) { var d = [], b = [], i, j, c, n; for (i in S) { j = 0, c = A.indexOf(S[i]); if (c < 0) return undefined; c || b.length ^ i ? i : b.push(0); while (j in d || c) { n = d[j]; n = n ? n * 58 + c : c; c = n >> 8; d[j] = n % 256; j++ } } while (j--) b.push(d[j]); return new Uint8Array(b) };

var MAP = "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";
// Generate a new keypair

function addressFormat(originalString) {
    var prefixLength = 8; // Number of characters to show from the beginning
    var suffixLength = 7; // Number of characters to show from the end

    var prefix = originalString.substring(0, prefixLength);
    var suffix = originalString.substring(originalString.length - suffixLength);
    return truncatedString = prefix + "..." + suffix;
}

function getAccountDetails() {
    const account = getAccount(modal.wagmiConfig);
    // if (account.address != undefined) {
    //     disconnectWallet();
    // }
    return account;
}

const account = getAccountDetails();


let provider;
const getProvider = () => {

    if ('solflare' in window) {
        const provider = window.solflare;
        return provider;
    } else {
        return null;
    }
};
function connectWallet() {
    modal.open({ view: "Connect" });
}

$(".connectWallet").on('click', function () {
    $("#connect-wallet").modal("hide");
    modal.open({ view: "Connect" });
})
$(document).on('click', "#solflareWallet", async function (event) {
    $("#connect-wallet").modal("hide");
    provider = getProvider()
    if (!window.solflare) {
        Toast("Please install solflare extensions", 3000, 0);
    }
    console.log("Solana provider", provider);
    console.log(provider.isConnected, 'provider.isConnected');
    let connect = await provider.connect();
    console.log(connect, 'provider.isConnected');
    // provider.on('connect', () => {
    console.log('Connected to provider');
    console.log(provider.listenerCount())
    const message = `Sign this message to prove that you own this address.`;
    const encodedMessage = new TextEncoder().encode(message);
    const signedMessage = await provider.signMessage(encodedMessage, "utf8").then(function (response, error) {
        if (!error) {
            // Login ajax call
            const Messge = `Thehuskyinu:${Math.random().toString(36).substring(2)}`;
            let url = getBaseURL() + "/signin";
            const accNO = provider.publicKey.toString();
            console.log(accNO, "accNO");
            const data = {
                selectedAccount: accNO,
                msg: Messge,
            };

            console.log(data, "data");
            postAjax(url, data, function (res) {
                if (res.flag == 1) {
                    Toast(res.msg, 3000, res.flag);
                    setCookie('walletType', 'solflare', 7);
                    console.log(res, "connectButton_console");
                    $(".connectBtn").css('display', 'none');
                    $("#connectAccNo").text(accNO).css('display', 'inline-block');
                    // var truncatedString = addressFormat(accNO);
                    // $(".connectAddress").text(truncatedString)
                    $("#disconnect").css('display', 'inline-block');
                    setTimeout(() => {
                        location.reload();
                    }, 1000);
                } else {
                    Toast(res.msg, 3000, res.flag);
                }
            });
            console.log("=============================okay ");
        }
        console.log("Sign Response => ", response, error)
    }).catch((error) => {
        console.log("Catch ERROR =>", error)
    });
    console.log(provider.publicKey.toString(), 'address');

    // });
    console.log(provider, "provider");
    $('#address').text(provider.publicKey.toString());

})

function getPlatform() {
    const userAgent = navigator.userAgent || navigator.vendor || window.opera;

    if (/windows phone/i.test(userAgent)) {
        return "Windows_Phone";
    }
    if (/android/i.test(userAgent)) {
        return "Android";
    }
    if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
        return "iOS";
    }
    return "Desktop";
}
const checkAndRedirect = async () => {
    const isPhantomInstalled = await isPhantomWalletInstalled();
    if (isPhantomInstalled) {
        connectPhantom();
    } else {
        Toast("Install Phantom wallet to proceed.", 3000, 0);
    }
};


const isPhantomWalletInstalled = async () => {
    // Custom URL scheme to check if Phantom is installed
    const customScheme = "phantom://";

    return new Promise((resolve) => {
        const iframe = document.createElement("iframe");
        iframe.style.display = "none";
        iframe.src = customScheme;
        document.body.appendChild(iframe);

        setTimeout(() => {
            document.body.removeChild(iframe);
            resolve(true); // If the custom scheme successfully opened, Phantom is installed
        }, 2000); // Adjust timeout as needed
    });
};

const encryptPayload = (payload, sharedSecret) => {
    if (!sharedSecret) throw new Error("missing shared secret");

    const nonce = nacl.randomBytes(24);
    var jsonString = JSON.stringify(payload);
    const payloadArray = new TextEncoder().encode(jsonString);
    const encryptedPayload = nacl.box.after(
        payloadArray,
        nonce,
        sharedSecret
    );
    return [nonce, encryptedPayload];
};

const connectPhantom = async () => {
    try {
        // alert(JSON.stringify(nacl.box.keyPair()));
        const params = new URLSearchParams({
            //   dapp_encryption_public_key: bs58.encode(dappKeyPair.publicKey),
            dapp_encryption_public_key: to_b58(dappKeyPair.publicKey, MAP),
            cluster: "mainnet-beta",
            app_url: onConnectRedirectLink,
            redirect_link: onConnectRedirectLink,
        });

        // url= "https://phantom.app/ul/v1/connect?"+params.toString()
        const url = buildUrl("connect", params);
        window.location.href = url;
    } catch (error) {
        Toast("Something went to wrong", 3000, 0);
    }
};

const signMessagePhantom = async (session, sharedSecret) => {
    try {
    const message = `Thehuskyinu:${Math.random().toString(36).substring(2)}`;
    localStorage.setItem('wallet_message', message);
    const payload = {
        session,
        message: to_b58(message, MAP),
        display: "hex"   
    };
    const [nonce, encryptedPayload] = encryptPayload(payload, sharedSecret);
   
    const params = new URLSearchParams({
        dapp_encryption_public_key: to_b58(dappKeyPair.publicKey, MAP),
        nonce: to_b58(nonce, MAP),
        redirect_link: onConnectRedirectLink,
        payload: to_b58(encryptedPayload, MAP),
    });
   
    const url = buildUrl("signMessage", params);
    window.location.href = url;
    }catch (error) {
        Toast("Something went to wrong, please try again", 3000, 0);
    }
};

const handleDeepLink = () => {
    if(platform !="Desktop"){
        const urlParams = new URLSearchParams(window.location.search);
        const publicKey = urlParams.get('phantom_encryption_public_key');
        const nonce = urlParams.get('nonce');
        const data = urlParams.get('data');
        if (publicKey) {
            const sharedSecret = nacl.box.before(
                from_b58(publicKey, MAP),
                dappKeyPair.secretKey
            );
            
            let decryptedData = decryptPayload(data, nonce, sharedSecret);
            localStorage.setItem('walletAddress', decryptedData.public_key);
            const session = decryptedData.session;
            signMessagePhantom(session, sharedSecret);
        } else {
            walletAddress = localStorage.getItem('walletAddress');
            wallet_message = localStorage.getItem('wallet_message');
            let walletType = getCookie('walletType');
            if(!publicKey && data && nonce && walletAddress  && typeof walletAddress !== 'undefined'  && wallet_message && !walletType ){
                const data = {
                    selectedAccount: walletAddress,
                    msg: wallet_message,
                };
                let url = getBaseURL() + "/signin";
                postAjax(url, data, function (res) {
                    if (res.flag == 1) {
                        Toast(res.msg, 3000, res.flag);
                        setCookie('walletType', 'phantom_solana', 7);
                        // console.log(res, "connectButton_console");
                        $(".connectBtn").css('display', 'none');
                        // $("#connectAccNo").text(accNO).css('display', 'inline-block');
                        // var truncatedString = addressFormat(walletAddress);
                        // $(".connectAddress").text(truncatedString)
                        $("#disconnect").css('display', 'inline-block');
                        setTimeout(() => {
                            location.reload();
                        }, 1000);
                    } else {
                        Toast(res.msg, 3000, res.flag);
                    }
                });
            }
        }
    }
};

const decryptPayload = (data, nonce, sharedSecret) => {
    if (!sharedSecret) throw new Error("missing shared secret");
    const decryptedData = nacl.box.open.after(
        from_b58(data, MAP),
        from_b58(nonce, MAP),
        sharedSecret
    );
    if (!decryptedData) {
        Toast("Something went to wrong, please try again", 3000, 0);
    }

    var jsonString = new TextDecoder().decode(decryptedData);
    var parsedObject = JSON.parse(jsonString);
    return parsedObject  //JSON.parse(Buffer.from(decryptedData).toString("utf8"));
};

document.addEventListener('DOMContentLoaded', (event) => {
    handleDeepLink();
});


const buildUrl = (path, params) =>
    // `https://phantom.app/ul/v1/${path}?${params.toString()}`;
    `phantom://v1/${path}?${params.toString()}`;



$(document).on('click', "#phantomWallet", async function (event) {
    $("#connect-wallet").modal("hide");
    if (window.phantom === undefined) {
        const platform = getPlatform();
        if (platform === "Desktop") {
            Toast("Please install phantom extensions", 3000, 0);
            return false;
        } else if (platform === "Android") {
            connectPhantom();
            return false;        
        } else if (platform === "iOS") {
            connectPhantom();
            return false;
        } else if (platform === "Windows_Phone") {
            connectPhantom();
            return false;
        }   
    }
    var provider = window.phantom.solana;
    if (provider.isOkxWallet == true && provider.isPhantom == true) {
        Toast("Please install phantom extensions", 3000, 0);
        return false;
    }
    console.log("Solana provider", provider);
    console.log(provider.isConnected, 'provider.isConnected');
    let connect = await provider.connect();
    console.log(connect, 'provider.isConnected');
    // provider.on('connect', () => {
    console.log('Connected to provider');
    console.log(provider.listenerCount())
    const message = `Sign this message to prove that you own this address.`;
    const encodedMessage = new TextEncoder().encode(message);
    const signedMessage = await provider.signMessage(encodedMessage, "utf8").then(function (response, error) {
        if (!error) {
            // Login ajax call
            const Messge = `Thehuskyinu:${Math.random().toString(36).substring(2)}`;
            let url = getBaseURL() + "/signin";
            const accNO = provider.publicKey.toString();
            console.log(accNO, "accNO");
            const data = {
                selectedAccount: accNO,
                msg: Messge,
            };

            console.log(data, "data");
            postAjax(url, data, function (res) {
                if (res.flag == 1) {
                    Toast(res.msg, 3000, res.flag);
                    setCookie('walletType', 'phantom', 7);
                    console.log(res, "connectButton_console");
                    $(".connectBtn").css('display', 'none');
                    // $("#connectAccNo").text(accNO).css('display', 'inline-block');
                    // var truncatedString = addressFormat(accNO);
                    // $(".connectAddress").text(truncatedString)
                    $("#disconnect").css('display', 'inline-block');
                    setTimeout(() => {
                        location.reload();
                    }, 1000);
                } else {
                    Toast(res.msg, 3000, res.flag);
                }
            });
            console.log("=============================okay ");
        }
        console.log("Sign Response => ", response, error)
    }).catch((error) => {
        console.log("Catch ERROR =>", error)
    });
    console.log(provider.publicKey.toString(), 'address');

    // });
    console.log(provider, "provider");
    $('#address').text(provider.publicKey.toString());

})

function updateAccountDisplay(account) {
    console.log('check account display-------------------');
    const accNO = account.adresss ? account.address : '';



    if (accNO) {
        console.log('=========== accNo-------------' + accNO);
        // $("#connectAccNo").text(accNO).css('display', 'inline-block');
        // var truncatedString = addressFormat(accNO);
        // $(".connectAddress").text(truncatedString)
    }
}

// /  For sign message
async function chkEvent(event) {
    console.log("Event ------------------------------- ", event);
    if (event === "CONNECT_SUCCESS") {
        console.log("Connected Successfully");

        const account = getAccountDetails();

        const Messge = `Thehuskyinu:${Math.random().toString(36).substring(2)}`;

        updateAccountDisplay(account);

        signMessage(modal.wagmiConfig, {
            account: account.address,
            message: Messge,
        }).then((signature, error) => {
            console.log("Signature ------------------------------- ", signature);
            console.log("Signature Error ------------------------------- ", error);

            let url = getBaseURL() + "/signin";
            const accNO = account.address;
            console.log(accNO, "accNO");
            const data = {
                selectedAccount: accNO,
                msg: Messge
            };


            console.log(data, "data");
            postAjax(url, data, function (res) {

                if (res.flag == 1) {
                    Toast(res.msg, 3000, res.flag);
                    console.log(res, "connectButton_console");
                    $("#disconnect").css('display', 'inline-block');
                    var truncatedString = addressFormat(account.address);
                    // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
                    // $(".connectAddress").text(truncatedString)
                    setTimeout(() => {
                        location.reload();
                    }, 1000);
                } else {
                    Toast(res.msg, 3000, res.flag);
                }
            });

        })
        // .catch((error) => {
        //     console.log("---------------------------------error=====================");

        //     console.log(error);
        //     debugger
        //     disconnectWallet();
        // });

        updateAccountDisplay(account);
    } else if (event === 'MODAL_CLOSE') {
        try {
            const account = getAccountDetails();
            if (!account.address) {
                return false;
            }
            const Messge = `Thehuskyinu:${Math.random().toString(36).substring(2)}`;
            signMessage(modal.wagmiConfig, {
                account: account.address,
                message: Messge,
            }).then((signature) => {
                console.log("Signature ------------------------------- ", signature);

                let url = getBaseURL() + "/signin";
                const accNO = account.address;
                console.log(accNO, "accNO");
                const data = {
                    selectedAccount: accNO,
                    msg: Messge
                };

                console.log(data, "data");
                postAjax(url, data, function (res) {
                    if (res.flag == 1) {
                        Toast(res.msg, 3000, res.flag);
                        console.log(res, "connectButton_console");
                        $("#disconnect").css('display', 'inline-block');
                        var truncatedString = addressFormat(account.address);
                        // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
                        // $(".connectAddress").text(truncatedString)
                        setTimeout(() => {
                            location.reload();
                        }, 1000);
                    } else {
                        Toast(res.msg, 3000, res.flag);
                    }
                });

            })
            // .catch((error) => {
            //     console.log(error);
            //     disconnectWallet();
            // });

            updateAccountDisplay(account);

        } catch (error) {
            console.log("Error in catch" + error);

        }
    }
    console.log(signMessage, "signMessage");
}



//  For Disconnect wallet
async function disconnectWallet() {


    await disconnect(modal.wagmiConfig);
    let url = getBaseURL() + "/logout";
    const data = {};
    postAjax(url, data, function (res) {
        if (res.flag == 1) {
            Toast(res.msg, 3000, res.flag);
            $("#disconnect").css('display', 'none');

            setTimeout(function () {
                location.reload();
            }, 1000);
        }
    });
    console.log("================ function =---------------------------disconnect");
}
$("#FinalyDisconnet").on('click', function () {
    $("#disconnect-wallet").modal('hide');
    $("#disconnectConformation").modal("hide");
    var cookies = document.cookie.split(";");

    for (var i = 0; i < cookies.length; i++) {
        var cookie = cookies[i];
        while (cookie.charAt(0) == ' ') {
            cookie = cookie.substring(1);
        }
        if (cookie.indexOf("user_id=") == 0 ||
            cookie.indexOf("order_id=") == 0 ||
            cookie.indexOf("currency=") == 0 ||
            cookie.indexOf("currency_symbol=") == 0 ||
            cookie.indexOf("payment_address=") == 0 ||
            cookie.indexOf("payment_qr=") == 0 ||
            cookie.indexOf("status=") == 0) {
            var parts = cookie.split("=");
            var name = parts[0];
            var path = "/";
            document.cookie = name + "=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=" + path;
        }
    }
    let walletType = getCookie('walletType');
    if (walletType == "solflare") {
        disconnectWalletSolflare();
    }else if (walletType == "phantom_solana") {
        disconnectPhantomSolana();
    } else {
        disconnectWallet();
    }
    let url = getBaseURL() + "/logout";
    const data = {};
    postAjax(url, data, function (res) {
        if (res.flag == 1) {
            Toast(res.msg, 3000, res.flag);
            $(".connectBtn").css('display', 'inline-block');
            $("#disconnect").css('display', 'none');
            setTimeout(() => {
                location.reload();
            }, 1000);
        }
    });

});

$("#disconnect").on("click", function () {
    $("#disconnect-wallet").modal('hide');
    $("#disconnectConformation").modal("show");
    $("#nobtn").css("display", 'inline-block');
    $("#okayBtn").addClass("d-none");
    $("#text").text("Are you sure want to disconnect wallet?");
    $("#FinalyDisconnet").css("display", 'inline-block');

})
$(document).ready(function () {
    const account = getAccount(modal.wagmiConfig);
    console.log("------------- getAccount ----------------" + account);
    if (account.address != undefined) {
        console.log("------------- conecti----------------");
        console.log("------------- conecti----------------" + account.address);

        // $(".connectBtn").css('display', 'none');
        var truncatedString = addressFormat(account.address);
        // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
        // $(".connectAddress").text(truncatedString)
        $("#disconnect").css('display', 'inline-block');
    }
})
async function disconnectWalletSolflare() {
    await provider.disconnect();
    setCookie('walletType', '', { expires: -1 });
}
async function disconnectPhantomSolana() {
    setCookie('walletType', '', { expires: -1 });
    localStorage.setItem('walletAddress','');
}
$(document).ready(function () {
    provider = getProvider();
    console.log("=================----provider-----------------------", provider);
    let walletType = getCookie('walletType');
    console.log(walletType);
    if (walletType == "solflare") {
        provider.connect().then(async (connect) => { // Use then() to detach async operation
            if (provider.isConnected) {
                console.log("Solana provider==================", provider);
                console.log(provider.isConnected, 'provider.isConnected');
                $("#disconnect").css('display', 'inline-block');
                var truncatedString = addressFormat(provider.publicKey.toString());
                // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
                // $(".connectAddress").text(truncatedString)
            }
        });
    } else if (walletType == "phantom") {
        var provider = window.phantom.solana;
        provider.connect().then(async (connect) => { // Use then() to detach async operation
            if (provider.isConnected) {
                console.log("phantom provider==================", provider);
                console.log(provider.isConnected, 'provider.isConnected');
                $("#disconnect").css('display', 'inline-block');
                var truncatedString = addressFormat(provider.publicKey.toString());
                // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
                // $(".connectAddress").text(truncatedString)
            }
        });
    }else if (walletType == "phantom_solana") {
        walletAddress = localStorage.getItem('walletAddress');
        if(walletAddress && typeof walletAddress!== undefined){
            $("#disconnect").css('display', 'inline-block');
            var truncatedString = addressFormat(provider.publicKey.toString());
            // $("#connectAccNo").text(truncatedString).css('display', 'inline-block');
            // $(".connectAddress").text(truncatedString) 
        }   
    }     
});
modal.subscribeEvents((event) => {
    chkEvent(event.data.event)
});
